﻿using System;
using System.Drawing;

using DevExpress.Utils;
using DevExpress.Utils.VisualEffects;
using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 가이드 1을 설정한다.

            Guide guide1 = new Guide();

            guide1.TargetElement = this.panelControl1;

            this.adornerUIManager.Elements.Add(guide1);

            #endregion
            #region 가이드 2를 설정한다.

            Guide guide2 = new Guide();

            guide2.TargetElement = this.panelControl2;

            this.adornerUIManager.Elements.Add(guide2);

            #endregion
            #region 가이드 3을 설정한다.

            Guide guide3 = new Guide();

            guide3.TargetElement = this.panelControl3;

            this.adornerUIManager.Elements.Add(guide3);

            #endregion
            #region 이벤트를 설정한다.

            this.showButton.Click                         += showButton_Click;
            this.adornerUIManager.QueryGuideFlyoutControl += adornerUIManager_QueryGuideFlyoutControl;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 가이드 표시 버튼 클릭시 처리하기 - showButton_Click(sender, e)

        /// <summary>
        /// 가이드 표시 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void showButton_Click(object sender, EventArgs e)
        {
            this.adornerUIManager.ShowGuides = DefaultBoolean.True;
        }

        #endregion
        #region 어도너 UI 관리자 가이드 플라이아웃 컨트롤 처리하기 - adornerUIManager_QueryGuideFlyoutControl(sender, e)

        /// <summary>
        /// 어도너 UI 관리자 가이드 플라이아웃 컨트롤 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void adornerUIManager_QueryGuideFlyoutControl(object sender, QueryGuideFlyoutControlEventArgs e)
        {
            if(e.SelectedElement.TargetElement == this.panelControl1)
            {
                e.Control = new LabelControl
                {
                    AutoSizeMode = LabelAutoSizeMode.Vertical,
                    Width = 250,
                    Padding = new System.Windows.Forms.Padding(10),
                    BackColor = Color.LightYellow,
                    AllowHtmlString = true,
                    Text = "<b>패널 1</b><br>패널 1 컨트롤 입니다."
                };
            }
            else if(e.SelectedElement.TargetElement == this.panelControl2)
            {
                e.Control = new LabelControl
                {
                    AutoSizeMode = LabelAutoSizeMode.Vertical,
                    Width = 250,
                    Padding = new System.Windows.Forms.Padding(10),
                    BackColor = Color.LightYellow,
                    AllowHtmlString = true,
                    Text = "<b>패널 2</b><br>패널 2 컨트롤 입니다."
                };
            }
            else if(e.SelectedElement.TargetElement == this.panelControl3)
            {
                e.Control = new LabelControl
                {
                    AutoSizeMode = LabelAutoSizeMode.Vertical,
                    Width = 250,
                    Padding = new System.Windows.Forms.Padding(10),
                    BackColor = Color.LightYellow,
                    AllowHtmlString = true,
                    Text = "<b>패널 3</b><br>패널 3 컨트롤 입니다."
                };
            }
        }

        #endregion
    }
}